#!/bin/bash

SRCDIR=`pwd`/..
BUILDDIR=`pwd`/Build

function source_clean()
{
  rm -rf $BUILDDIR
}

function compile()
{
  echo ChunkSched: $1 PeerSched: $2 >> $3
  ORIGDIR=`pwd`
  mkdir -p $BUILDDIR
  cd       $BUILDDIR
  make -f $SRCDIR/Makefile SRC=$SRCDIR NO_BUFF=1 CHUNK_SCHED=$1 PEER_SCHED=$2
  cd       $ORIGDIR
}

function test()
{
  echo $2 chunks on $1 peers, $3 neighbours per peer  >> $4
  (time $BUILDDIR/sssim -c $2 -n $1 -o $3 >> $4)     2>> $4
  echo
  echo
}

function run_tests()
{
  source_clean
  compile $1 $2 $3

  test 256 600 256 $3
  test 200 600 200 $3
  test 500 600 500 $3

  test 256 600 10 $3
  test 200 600 10 $3
  test 500 600 10 $3

  test 256 600 20 $3
  test 200 600 20 $3
  test 500 600 20 $3
}


run_tests latest_useful_chunk ch_useful_peer_random results
run_tests dl_sched            ch_useful_peer_random results
run_tests random_useful_chunk ch_useful_peer_random results
run_tests latest_useful_chunk ch_earliest_free_peer results
run_tests dl_sched            ch_earliest_free_peer results
run_tests random_useful_chunk ch_earliest_free_peer results

