/*
 * This is SSSim: the Simple & Stupid Simulator
 *
 *  Copyright (c) 2008 Luca Abeni
 *  Copyright (c) 2008 Csaba Kiraly
 *
 *  This is free software; see gpl-3.0.txt
 */

struct peer {
  struct chunk_instance **chunks;
  struct chunk_instance **recv_chunks;
  int key;
  int id;
  int latest_not_needed;
  struct peer **neighbour;
  int neigh_size;
  int num_chunks;
  int buf_size;
  int buf_mask;
};

struct chunk {
  int received;
  float avg_delay;
  int max_delay;
};

struct chunk_instance {
  int chunk;
  int dl;
  int key;
  int completed;
};


#define min(X, Y)  ((X) < (Y) ? (X) : (Y))
#define max(X, Y)  ((X) > (Y) ? (X) : (Y))

int comp(int chunk);

extern FILE *trace;    //trace file
extern int PO_DELAY;

static inline int win_right(struct peer *p, int t)
{
  return min(t, p->num_chunks);
}

#ifdef NO_BUFFER
static inline int win_left(struct peer *p, int t)
{
  return 0;
}

static inline int win_idx(struct peer *p, int i)
{
  return i;
}

static inline int in_buffer(struct peer *p, int c, int t)
{
  return 1;
}
#else
static inline int win_left(struct peer *p, int t)
{
  return max(0, min(t + 1, p->num_chunks) - p->buf_size);
}

static inline int win_idx(struct peer *p, int i)
{
  return i & p->buf_mask;
}

static inline int in_buffer(struct peer *p, int i, int t)
{
  return p->chunks[win_idx(p, i)]->chunk > t - p->buf_size;
}
#endif
